accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import signup


urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path
from projects.views import (
    ProjectCreateView,
    ProjectDetailView,
    ProjectListView,
)


urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tasks/urls.py
from django.urls import path
from tasks.views import (
    TaskDetailView,
    TaskListView,
    TaskCreateView,
    TaskUpdateView,
)


urlpatterns = [
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/", TaskDetailView.as_view(), name="detail_tasks"),
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView


urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
]

accounts/models.py
# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings

# Create your models here.

USER_MODEL = settings.AUTH_USER_MODEL


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models
from django.conf import settings
from django.utils import timezone


# Create your models here.

USER_MODEL = settings.AUTH_USER_MODEL


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField(default=timezone.now)
    due_date = models.DateTimeField(default=timezone.now)
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project", related_name="tasks", on_delete=models.CASCADE
    )
    assignee = models.ForeignKey(
        USER_MODEL, null=True, related_name="tasks", on_delete=models.SET_NULL
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth import login

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(username, password)
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

projects/views.py
from django.shortcuts import redirect
from django.views.generic.list import ListView
from projects.models import Project
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView


# Create your views here.


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/create.html"
    fields = ["name", "description", "members"]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("show_project", pk=owner.id)

tasks/views.py
from django.shortcuts import redirect
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.list import ListView
from tasks.models import Task
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView
from django.urls import reverse_lazy


# Create your views here.


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskDetailView(LoginRequiredMixin, DetailView):
    model = Task
    template_name = "projects/detail.html"

    def get_queryset(self):
        return Task.objects.filter(members=self.request.user)


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/create.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("detail_tasks", pk=owner.id)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    fields = ["is_completed"]

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)

    def get_success_url(self) -> str:
        return reverse_lazy("show_my_tasks")

projects/templates/projects/create.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Create Project</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}" />
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        <main>
            <div>
                <h1>Create a new project</h1>
                <form method="post">
                    {% csrf_token %} {{ form.as_p }}
                    <button class="button">Create</button>
                </form>
            </div>
        </main>
    </body>
</html>

projects/templates/projects/detail.html
{% load static %} {% load markdownify %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Details</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}" />
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        <main>
            <div>
                <h1>{{ project.name }}</h1>
                {{ project.description|markdownify }}
                <h2>Tasks</h2>
                <p><a href="{% url 'create_task' %}">Create a new task</a></p>
                {% if project.tasks.all %}
                    <table>
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Assignee</th>
                                <th>Start date</th>
                                <th>Due date</th>
                                <th>Is completed</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for info in project.tasks.all %}
                                <tr>
                                    <td>{{ info.name }}</td>
                                    <td>{{ info.assignee }}</td>
                                    <td>{{ info.start_date }}</td>
                                    <td>{{ info.due_date }}</td>
                                    {% if info.is_completed %}
                                        <td>Yes</td>
                                    {% else %}
                                        <td>No</td>
                                    {% endif %}
                                </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                {% else %}
                    <p>This project has no tasks</p>
                {% endif %}
            </div>
        </main>
        <footer></footer>
    </body>
</html>

projects/templates/projects/list.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>List</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}" />
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'create_project' %}">Create Project</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        <main>
            <div>
                <h1>My Projects</h1>
                {% if not project_list %}
                    <p>You are not assigned to any projects.</p>
                {% else %}
                    <table>
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Number of tasks</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for activity in project_list %}
                                <tr>
                                    <td>
                                        <a href="{% url 'show_project' activity.pk %}">
                                            {{ activity.name }}
                                        </a>
                                    </td>
                                    <td>{{ activity.tasks.all|length }}</td>
                            {% endfor %}
                        </tr>
                {% endif %}
            </tbody>
        </table>
    </div>
</main>
<footer></footer>
</body>
</html>

tasks/templates/tasks/create.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Create Task</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}" />
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        <main>
            <div>
                <h1>Create a new task</h1>
                <form method="post">
                    {% csrf_token %} {{ form.as_p }}
                    <button class="button">Create</button>
                </form>
            </div>
        </main>
    </body>
</html>

tasks/templates/tasks/list.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Create Task</title>
        <link rel="stylesheet" href="{% static 'css/app.css' %}" />
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li>
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li>
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li>
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li>
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li>
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        <main>
            <div>
                <h1>My Tasks</h1>
                {% if task_list %}
                    <table>
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Start date</th>
                                <th>End date</th>
                                <th>Is completed</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for assignment in task_list %}
                                <tr>
                                    <td>{{ assignment.name }}</td>
                                    <td>{{ assignment.start_date }}</td>
                                    <td>{{ assignment.due_date }}</td>
                                    {% if assignment.is_completed %}
                                        <td>Done</td>
                                    {% else %}
                                        <td>
                                            <form
                                                method="post"
                                                action="{% url 'complete_task' assignment.id %}"
                                            >
                                                {% csrf_token %}
                                                <input type="hidden" name="is_completed" value="True" />
                                                <button>Complete</button>
                                            </form>
                                        </td>
                                    {% endif %} {% endfor %}
                        </tr>
                {% else %}
                    <p>You have no tasks</p>
                {% endif %}
            </tbody>
        </table>
    </div>
</main>
</body>
</html>